gss_wrap(3)

NAME
gss_wrap - API function

SYNOPSIS
#include <gss.h>

OM_uint32 gss_wrap(OM_uint32 * minor_status, const gss_ctx_id_t context_handle, int conf_req_flag, gss_qop_t qop_req, const gss_buffer_t input_message_buffer, int * conf_state, gss_buffer_t output_message_buffer);

ARGUMENTS

OM_uint32 * minor_status
    (Integer, modify) Mechanism specific status code.

const gss_ctx_id_t context_handle
    (gss_ctx_id_t, read) Identifies the context on
      which the message will be sent.

int conf_req_flag
    (boolean, read) Non-zero - Both confidentiality and
      integrity services are requested. Zero - Only integrity service is
      requested.

gss_qop_t qop_req
    (gss_qop_t, read, optional) Specifies required quality of
      protection. A mechanism-specific default may be requested by
      setting qop_req to GSS_C_QOP_DEFAULT. If an unsupported
      protection strength is requested, gss_wrap will return a
      major_status of GSS_S_BAD_QOP.

const gss_buffer_t input_message_buffer
    (buffer, opaque, read) Message to be
      protected.

int * conf_state
    (boolean, modify, optional) Non-zero -
      Confidentiality, data origin authentication and integrity
      services have been applied. Zero - Integrity and data origin
      services only has been applied. Specify NULL if not required.

gss_buffer_t output_message_buffer
    (buffer, opaque, modify) Buffer to receive
      protected message. Storage associated with this message must be
      freed by the application after use with a call to
      gss_release_buffer().

DESCRIPTION
Attaches a cryptographic MIC and optionally encrypts the specified input_message. The output_message contains both the MIC and the message. The qop_req parameter allows a choice between several cryptographic algorithms, if supported by the chosen mechanism.

Since some application-level protocols may wish to use tokens emitted by gss_wrap() to provide "secure framing", implementations must support the wrapping of zero-length messages.

RETURN VALUE

`GSS_S_COMPLETE`: Successful completion.

`GSS_S_CONTEXT_EXPIRED`: The context has already expired.

`GSS_S_NO_CONTEXT`: The context_handle parameter did not identify a
 valid context.

`GSS_S_BAD_QOP`: The specified QOP is not supported by the mechanism.

REPORTING BUGS
Report bugs to <bug-gss@gnu.org>. GNU Generic Security Service home page: http://www.gnu.org/software/gss/ General help using GNU software: http://www.gnu.org/gethelp/

COPYRIGHT
Copyright © 2003-2022 Simon Josefsson.
Copying and distribution of this file, with or without modification, are permitted in any medium without royalty provided the copyright notice and this notice are preserved.

SEE ALSO
The full documentation for gss is maintained as a Texinfo manual. If the info and gss programs are properly installed at your site, the command

    info gss

should give you access to the complete manual.